/* $Id: expand.h,v 2.2 1991/12/18 15:14:56 cogito Exp $ */

/***********************************************************************\
*									*
*		Implementation of LIGA expand pass			*
*									*
*	Module:		expand.c					*
*	File:		expand.h					*
*	Contents:	main function of expand pass			*
*	Author:		Hans Detlef Siewert				*
*	Creation date:	12 Dec 1990					*
*	Last change:	17 Apr 1991					*
*									*
\***********************************************************************/

#ifndef _EXPAND_H_INCL
#define _EXPAND_H_INCL

/*
** MACROS
*/

#define	protout	if (EXP_PROT) (void)fprintf

/*
** GLOBAL VARIABLES
*/

extern	FILE	*InputFile;
extern	FILE	*OutputFile;
extern	FILE	*ProtocolFile;
extern	FILE	*ExpOptFile;
extern	FILE	*OptOutFile;

extern	char	*CONST_ATTR;
extern	int	EXP_PROT;
extern	int	EXP_INCL;
extern	char	*INCL_ATTR;
extern	int	IDENT_INCL;
extern	char	*CHAIN_PRE_ATTR;
extern	char	*CHAIN_POST_ATTR;

extern	char	*NULL_FUNC;
extern	char	*CREAT_FUNC;
extern	char	*CONCAT_FUNC;

/*
** GLOBAL FUNCTIONS
*/

#ifdef __STDC__
extern void deadly (char *msg);
extern void fatal (char *msg);
extern void print_err (int row, int col, char *str, int id);
extern void print_warn (int row, int col, char *str, int id);
extern void print_note (int row, int col, char *str);
#else
extern void deadly();
extern void fatal();
extern void print_err();
extern void print_warn();
extern void print_note();
#endif

#endif

/***********************\
* end of expand.h	*
\***********************/

								/* HaDeS */

